**Note:** The logo of this project is based on the [bird ref sheet](https://www.furaffinity.net/view/23640147/) created by [Lainn](https://www.furaffinity.net/user/lainn/) - If you use this logo, make sure to credit them.

## BirdyNet
A lightweight and modular browser based on Python and Qt, soon to have its own HTML and CSS interpreter and display engine.

![Screenshot](assets/screenshot.png)

This browser is still in a very early stage. Inputting data, downloading files and uploading are not possible yet. JavaScript will not be supported, video/audio media will pop out into your preferred player.

## Prerequisites
> #### 🌟 Python 3.4.4 or newer (older versions may work, but aren't tested)
> **Windows:** [Download](https://www.python.org/downloads/)  
> **Debian:** `apt-get install python3`  
_**Note:** Windows 7 support was dropped with Python 3.9 (Thanks, asshats), use Python 3.8.x, on 7._  

> #### 🌟 QtPy
> **Windows:** `py -m pip install QtPy`  
> **Debian:** `apt-get install python3-qtpy`  

> #### 🌟 A Qt library compatible with QtPy
> There is multiple choices, QtPy is compatible with PyQt5, PyQt4, PySide2 and PySide. Don't know what to choose? You probably want PyQt5:  
> **Windows:** `py -m pip install PyQt5`  
> **Debian:** `apt-get install python3-pyqt5`  